// Beycan Kahraman 15.08.2009

#include "cv.h"
#include "highgui.h"
#include <stdio.h>

int main( int argc, char** argv )
{
	static CvMemStorage* storage = cvCreateMemStorage(0);
	static CvHaarClassifierCascade* cascade = 0;

	cascade = (CvHaarClassifierCascade*)cvLoad( "haarcascade_frontalface_alt.xml", 0, 0, 0 );

	if( !cascade )
	{
		fprintf( stderr, "ERROR: Could not load 'classifier cascade'\n" );
		system("PAUSE");
		return -1;
	}

	cvNamedWindow( "Yuz", 1 );

	while(true) {
		IplImage* frame = cvLoadImage("beycan.jpg", 1), *img;
		if( !frame )
			break;
		img = cvCloneImage(frame); img->origin = 0;
		if( frame->origin ) cvFlip(img, img);
		cvClearMemStorage( storage );
		CvSeq* faces = cvHaarDetectObjects( img, cascade, storage,
			1.1, 2, CV_HAAR_DO_CANNY_PRUNING, cvSize(20, 20) );
		for( int i = 0; i < (faces ? faces->total : 0); i++ ) {
			CvRect* r = (CvRect*)cvGetSeqElem( faces, i );
			cvRectangle( img, cvPoint(r->x,r->y),
				cvPoint(r->x+r->width,r->y+r->height),
				CV_RGB(255,0,0), 3 );
		}
		cvShowImage( "Yuz", img );
		cvReleaseImage( &img );
		if( cvWaitKey(10) >= 0 ) break;
	}

	system("PAUSE");
	return 0;
}